precision mediump float;
uniform sampler2D u_TextureUnit;
varying vec2 v_TextureCoordinates;
uniform highp float texelWidthOffset;
uniform highp float texelHeightOffset;
uniform highp float pixel;

void main()
{
   vec2 uv  = v_TextureCoordinates.xy;
   highp float dx = pixel * texelWidthOffset;
   highp float dy = pixel * texelHeightOffset;

   highp float scale=texelWidthOffset/texelHeightOffset;
   // 计算一个马赛克的中心坐标
   vec2 coord = vec2(dx * floor(uv.x / dx) + 0.5 * dx, dy * floor(uv.y / dy) + 0.5 * dy);
   // 计算当前像素距离所在马赛克中心的长度


   vec4 finalColor;
   bool isin=false;

      vec2 delXY = coord - uv;

      //判断是否在椭圆里面
      //f(x,y)= x^2/a^2 + y^2/b^2=1,
      //f(x1,y1) <1说明x1,y1在椭圆内部
      highp float maxpos;
      highp float minpos;
      if(texelWidthOffset<texelHeightOffset){
      maxpos=delXY.y;
      minpos=delXY.x;
      }else{
      minpos=delXY.y;
      maxpos=delXY.x;
      }

      highp float maxr=max(texelWidthOffset,texelHeightOffset)*pixel/2.0;
      highp float minr=min(texelWidthOffset,texelHeightOffset)*pixel/2.0;
      isin=(((maxpos*maxpos)/(maxr*maxr)+(minpos*minpos)/(minr*minr))<=1.0);


      //highp float delL = length(delXY);
      //isin=(delL < 0.3 * dx);


   if(isin)
   {
      finalColor = texture2D(u_TextureUnit, coord);
   }
   else
   {
      finalColor = vec4(0., 0., 0., 0.);
   }

   gl_FragColor = finalColor;
}